#define EDIT PD6
#define EDITPORT PORTD
#define EDITDDR DDRD

#define GALSENSE PC2
#define GALSENSEPIN PINC

#define PV PB0			//NOTE, this may need a pulldown externally
#define SCLK PB4
#define SDIN PB3
#define STB PB2

#define SDOUT PINA0
#define SDOUTPIN PINA

#define GALCTRLPORT PORTB
#define GALCTRLDDR  DDRB
#define GALCTRLPIN	PINB

//Calling GAL PA0 - 5 GALPA0 - 5 to avoid name conflicts

#define GALPA0 PD3
#define GALPA0PORT PORTD

#define GALPA1 PC0
#define GALPA1PORT PORTC

#define GALPA2 PC1
#define GALPA2PORT PORTC

#define GALPA3 PB7
#define GALPA3PORT PORTB

#define GALPA4 PB6
#define GALPA4PORT PORTB

#define GALPA5 PB5
#define GALPA5PORT PORTB

/*
#define GALPA0 PA0
#define GALPA1 PA1
#define GALPA2 PA2
#define GALPA3 PA3
#define GALPA4 PA4
#define GALPA5 PA5

#define GALADPORT PORTA
#define GALADDDR DDRA
*/

//Port A has input on 0, but all others are VIL, so need to be asserted as outputs
#define PORTA_GAL_DDR ~_BV(0)

//Port B has outputs on 5, 6, 7
//PB0 is output, and PB1 is undesirable high, so it stays that way.  All others are data pins
#define PORTB_GAL_DDR 0xFF

//0 and 1 are outputs
#define PORTC_GAL_DDR 0x03

//Port D has outputs on 2, 3, 4, 6, 7
#define PORTD_GAL_DDR 0xDC

typedef enum { UNKNOWN, GAL22V10 } GALTYPE;

typedef struct {
	GALTYPE type;
	unsigned char id0, id1;
	char *name;
	int fuses;
	int pins;
	int rows;
	int bits;
	int uesrow;
	int uesfuse;
	int uesbytes;
	int eraserow;
	int eraseallrow;
	int pesrow;
	int pesbytes;
	int cfgrow;
	int *cfg;
	int cfgbits;
} GALINFO;

#define LATTICE 0xA1
#define NATIONAL 0x8F
#define SGSTHOMSON 0x20

#define READGAL 0
#define VERIFYGAL 1
#define READPES 2
#define SCLKTEST 3
#define WRITEGAL 4
#define ERASEGAL 5
#define ERASEALL 6
#define BURNSECURITY 7
#define WRITEPES 8
#define VPPTEST 9

int readJEDEC(void);
void EraseGAL(void);
void ReadPES(void);
void ParsePES(int DisplayPES);
void WriteGAL(int ones);
int ReadGAL(char verify);
void PrintFuses(void);
