#define PIC16F628 0x3E
#define PIC16F628A 0x83

#define PIC16F627  0x3D
#define PIC16F627A 0x82

#define PIC16F648A 0x88

#define LOAD_CONFIG_COMMAND 0x00
#define LOAD_PROGRAM_COMMAND 0x02
#define LOAD_DATA_COMMAND 0x03
#define INCREMENT_ADDRESS 0x06
#define READ_PROGRAM_COMMAND 0x04
#define READ_DATA_COMMAND 0x05

//The following command is for no A
//A version calls this Program Only
#define BEGIN_ERASE_PROGRAM 0x08
#define A_PROGRAM_ONLY 0x08

//Just for old chip
#define BEGIN_PROGRAM_ONLY 0x18

#define BULK_ERASE_PROGRAM 0x09
#define BULK_ERASE_DATA 0x0B

//Just for old chip
//Used to hose code protection bits
#define BULK_ERASE_SETUP_ONE 0x01
#define BULK_ERASE_SETUP_TWO 0x07

//This is the definition for the PIC burning pins
#define VSS        PB6
#define VDD        PA3
#define VPP        PB7
#define PGM        PB2
#define CLOCK      PA1
#define DATA       PA2

#define PICSENSE PB6
#define PICSENSEPIN PINB

//PB2,PB7 are outputs. PB6 input
//PA1, output, PA2 is both (calling an input in default
#define PORTB_PIC_DDR 0x84
#define PORTA_PIC_DDR 0x02
#define VSSDDR      DDB6
#define VSSPIN      PINB6
#define CLOCK_PORT  PORTA
#define DATA_PORT   PORTA
#define PGM_PORT    PORTB
#define VPP_PORT    PORTB
#define VSS_PORT    PORTB
#define VSS_DDR     DDRB
#define VSS_PIN     PINB
#define DATADDR     DDA2
#define DATA_DDR    DDRA
#define DATA_PIN    PINA
#define DATAIN      PINA2

//sets type of PIC
extern uint8_t PICtype;

//Data memory for the PIC to be burned
extern uint8_t picDataMemory[128];

//Configuration memory for the PIC to be burned
extern uint8_t picConfigMemory[16];

//void pic_enter_programming(void);
//void pic_exit_programming(void);
//void pic_pulse_clock(void);
//void pic_send_command(uint8_t comm);
//uint16_t pic_receive_data(void);
//void pic_send_data(uint16_t comm);
void pic_bulk_erase(void);
int pic_write_program(void);
int pic_write_data(void);
int pic_write_configuration(void);
uint8_t pic_get_revision(void);
void pic_view(void);
void pic_total_erase(void);
